//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "spDraw.hpp"
#include "spPixelArithmetics.hpp"
#include "spGeometry.hpp"
Byte **scLine;
int width, height;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "hyiedefs"
#pragma link "hyieutils"
#pragma link "ieopensavedlg"
#pragma link "iesettings"
#pragma link "ievect"
#pragma link "ieview"
#pragma link "iexBitmaps"
#pragma link "imageenview"
#pragma link "cspin"
#pragma link "hyiedefs"
#pragma link "hyieutils"
#pragma link "ieopensavedlg"
#pragma link "iesettings"
#pragma link "ievect"
#pragma link "ieview"
#pragma link "iexBitmaps"
#pragma link "imageenview"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
scLine = 0;
//imageContainer = 0;
width = 0;
height = 0;
randomize();
Label1->Caption = "";
Label5->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
//
clearContainer();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLoadClick(TObject *Sender)
{
if (openDialog->Execute())
   {
   clearContainer();
   PaintView->IO->LoadFromFile(openDialog->FileName);
   width  = PaintView->IEBitmap->Width;
   height = PaintView->IEBitmap->Height;
   scLine = new Byte*[height];
   for (int i = 0; i < height; i++)
	   scLine[i] = (Byte*)PaintView->IEBitmap->ScanLine[i];
   imageContainer = new TImageContainer(scLine, 0, width, height);
   PaintView->Zoom = 100;
   //imageContainer.SetImage(scLine, 0, width, height);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnTesselateClick(TObject *Sender)
{
if (width == 0 || height == 0)
   return;
Label1->Caption = "Processing...";
Label1->Refresh();
imageContainer->ImageOrig->Copy(imageContainer->ImageEdit);
TTime stime = Time(), etime, duration;
std::vector<TPoint> points, levelPts;
int iterations = edIterations->Value;
int ptsNum = edSites->Value;
int prevNum = ptsNum;
ptRGB pixIn, pixOut;
for (int i = 0; i < iterations; i++)
	{
	ptsNum = (ptsNum>>1);
	if (ptsNum < 3)
	   {
	   ptsNum = prevNum;
	   iterations = i + 1;
	   break;
	   }
	prevNum = ptsNum;
	}
//if (ptsNum < 3)
//   ptsNum = 3;
bool delaunay = (rgpTesselation->ItemIndex > 0);
bool edge = chkEdges->Checked;
// lowest level
createSites(points, ptsNum, delaunay);
int x, y;
float luminance[3] = {0.11, 0.59, 0.30};
float lumOut, lumIn, error = (float)edError->Value;
bool equal;
for (int i = 0; i < iterations; i++)
	{
	Label5->Caption = "Iteration: " + IntToStr(i + 1);
	Label5->Refresh();
	PaintView->LockPaint();
	tesselate(points, delaunay, (i == iterations-1 && edge), (rgpEdgeColor->ItemIndex > 0));
	ptsNum *= 2;
	if (i < iterations-1)
	   {
	   createSites(levelPts, ptsNum);
	   for (size_t k = 0; k < levelPts.size(); k++)
		   {
		   x = levelPts[k].x;
		   y = levelPts[k].y;
		   pixOut = imageContainer->ImageOrig->Pixel(y, x);
		   pixIn  = imageContainer->ImageEdit->Pixel(y, x);
		   lumOut = pixOut.ch[0]*luminance[0] + pixOut.ch[1]*luminance[1] + pixOut.ch[2]*luminance[2];
		   lumIn  = pixIn.ch[0]*luminance[0] + pixIn.ch[1]*luminance[1] + pixIn.ch[2]*luminance[2];
		   if (fabs(lumOut - lumIn) > error )
			  {
			  equal = false;
			  // do not add duplicated sites
			  for (size_t j = 0; j < points.size(); j++)
				  {
				  if (points[j].y == levelPts[k].y && points[j].x == levelPts[k].x)
					 {
					 equal = true;
					 break;
					 }
				  }
			  if (equal)
				 continue;
			  points.push_back(levelPts[k]);
			  }
		   }
	   }
	PaintView->UnLockPaint();
	PaintView->Paint();
	}
points.clear();
PaintView->Update();
etime = Time();
duration = etime - stime;
Label1->Caption = "Time elapsed: " + duration.FormatString("hh:nn:ss.zzzz");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::tesselate(std::vector<TPoint> &points, bool delaunay, bool edge, bool vertexColor)
{
std::vector<spGeometry::TLine> lines;
std::vector<Triangle> triples;
ptGray pixMask = ptGray(255);
//
spGeometry::VoronoiGenerate(points, lines, triples, width, height, 2.2);
//
if (delaunay)
   {
   int m;
   spDraw::spsColorTriangle<ptRGB> cTri;
   for (size_t i = 0; i < triples.size(); i++)
	   {
	   for (int k = 0; k < 3; k++)
		   {
		   //spDraw::Line(imageContainer->ImageOrig, pix2, x1, y1, x2, y2, 1);
		   cTri.x[k] = triples[i].s[k].coord.x;
		   cTri.y[k] = triples[i].s[k].coord.y;
		   cTri.val[k] = imageContainer->ImageEdit->Pixel(cTri.y[k], cTri.x[k]);
		   }
	   if (rgpTesselation->ItemIndex == 2)
		  spDraw::TriangleGouraud(imageContainer->ImageOrig, cTri);
	   else
		  spDraw::TriangleFilled(imageContainer->ImageOrig, cTri, -1);
	   }
   }
else
   {
	imageContainer->ImageMaskLeft->Fill(ptGray(0));
	for (size_t i = 0; i < lines.size(); i++)
		{
		spGeometry::TLine line = lines[i];
		spDraw::Line(imageContainer->ImageMaskLeft, pixMask, line.x1, line.y1, line.x2, line.y2, 1);
		}
	// fill
	int x, y;
	for (size_t i = 0; i < points.size(); i++)
		{
		x = points[i].x;
		y = points[i].y;
		try {
			spDraw::FloodFillConvex(imageContainer->ImageMaskLeft, imageContainer->ImageOrig, x, y, imageContainer->ImageEdit->Pixel(y, x));
			//spDraw::FloodFill(imageContainer->ImageMaskLeft, imageContainer->ImageOrig, x, y, imageContainer->ImageEdit->Pixel(y, x));
			}
		catch (...)
			{
			throw 1;
			// ups!!!
			}
		}
	}
//
ptRGB pixEdge = ptRGB(0, 0, 0);
ptRGB pixEdgeShadow  = ptRGB(64, 64, 64);
ptRGB pixVertex;
//
if (edge)
   {
   if (delaunay)
	  {
	  spDraw::spsColorTriangle<ptRGB> cTri, sTri;
	  for (size_t i = 0; i < triples.size(); i++)
		  {
		  for (int k = 0; k < 3; k++)
			  {
			  cTri.x[k] = triples[i].s[k].coord.x;
			  cTri.y[k] = triples[i].s[k].coord.y;
			  cTri.val[k] = imageContainer->ImageEdit->Pixel(cTri.y[k], cTri.x[k]);
			  sTri.x[k] = cTri.x[k] + 1;
			  sTri.y[k] = cTri.y[k] + 1;
			  }
		  if (chkFancy->Checked)
			 {
			 sTri.val[0] = pixEdgeShadow;
			 spDraw::Triangle(imageContainer->ImageOrig, sTri, edThickness->Value, 0);
			 }
		  if (vertexColor)
			 spDraw::Triangle(imageContainer->ImageOrig, cTri, edThickness->Value, -1);
		  else
			 {
			 cTri.val[0] = pixEdge;
			 spDraw::Triangle(imageContainer->ImageOrig, cTri, edThickness->Value, 0);
			 }
		  }
	  }
   else
	  {
	  for (size_t i = 0; i < lines.size(); i++)
		   {
		   spGeometry::TLine line = lines[i];
		   if (abs(line.x1 - line.x2) == 0 &&  abs(line.y1 - line.y2) == 0)
			  continue;
		   if (chkFancy->Checked)
			  spDraw::Line(imageContainer->ImageOrig, pixEdgeShadow, line.x1 + 1, line.y1 + 1, line.x2 + 1, line.y2 + 1, edThickness->Value);
		   if (vertexColor)
			  {
			  if (line.y1 < 0 || line.y1 > height-1 || line.x1 < 0 || line.x1 > width-1)
				 {
				 if (line.y2 < 0 || line.y2 > height-1 || line.x2 < 0 || line.x2 > width-1)
				 	continue;
				 }
			  else
			     pixVertex = imageContainer->ImageEdit->Pixel(line.y1, line.x1);
			  spDraw::Line(imageContainer->ImageOrig, pixVertex, line.x1, line.y1, line.x2, line.y2, edThickness->Value);
			  }
		   else
			  spDraw::Line(imageContainer->ImageOrig, pixEdge, line.x1, line.y1, line.x2, line.y2, edThickness->Value);
		   }
	  }
   }
lines.clear();
triples.clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::createSites(std::vector<TPoint> &inPts, int ptsNum, bool delaunay)
{
bool equal = false;
// if it's delaunay, put pixels in the image cornes. NOTE: put it only once!!!
TPoint pt;
if (delaunay)
   {
   pt.x = 0;
   pt.y = 0;
   inPts.push_back(pt);
   pt.x = width-1;
   pt.y = 0;
   inPts.push_back(pt);
   pt.x = width-1;
   pt.y = height-1;
   inPts.push_back(pt);
   pt.x = 0;
   pt.y = height-1;
   inPts.push_back(pt);
   }
for (int i = 0; i < ptsNum; i++)
	{
	pt.x = random(width  - 6) + 4;
	pt.y = random(height - 6) + 4;
	equal = false;
	// do not add duplicated sites
	for (size_t j = 0; j < inPts.size(); j++)
		{
		if (inPts[j].y == pt.y && inPts[j].x == pt.x)
		   {
		   equal = true;
		   break;
		   }
		}
	if (equal)
	   continue;
	inPts.push_back(pt);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::clearContainer(void)
{
if (scLine)
   {
   delete []scLine;
   scLine = 0;
   }
if (imageContainer)
   delete imageContainer;
}
//---------------------------------------------------------------------------

